'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactTinyVirtualList = require('react-tiny-virtual-list');

var _reactTinyVirtualList2 = _interopRequireDefault(_reactTinyVirtualList);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _reactScrollbarSize = require('react-scrollbar-size');

var _reactScrollbarSize2 = _interopRequireDefault(_reactScrollbarSize);

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _reactContainerDimensions = require('react-container-dimensions');

var _GridRow = require('./GridRow');

var _GridRow2 = _interopRequireDefault(_GridRow);

var _GridMath = require('./GridMath');

var _GridMath2 = _interopRequireDefault(_GridMath);

var _GridTextBox = require('./GridTextBox');

var _GridTextBox2 = _interopRequireDefault(_GridTextBox);

var _reactTooltip = require('react-tooltip');

var _reactTooltip2 = _interopRequireDefault(_reactTooltip);

var _PlaylistRemoveIcon = require('mdi-react/PlaylistRemoveIcon');

var _PlaylistRemoveIcon2 = _interopRequireDefault(_PlaylistRemoveIcon);

var _PlaylistPlusIcon = require('mdi-react/PlaylistPlusIcon');

var _PlaylistPlusIcon2 = _interopRequireDefault(_PlaylistPlusIcon);

var _DatePickerOverlay = require('./easyTools/DatePickerOverlay');

var _DatePickerOverlay2 = _interopRequireDefault(_DatePickerOverlay);

var _MenuPickerOverlay = require('./easyTools/MenuPickerOverlay');

var _MenuPickerOverlay2 = _interopRequireDefault(_MenuPickerOverlay);

var _AltTextOverlay = require('./easyTools/AltTextOverlay');

var _AltTextOverlay2 = _interopRequireDefault(_AltTextOverlay);

var _EasyBool = require('./easyTools/EasyBool');

var _EasyBool2 = _interopRequireDefault(_EasyBool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

// Wrapper for the grid
// This grid allows deep styling via style objects, 
// but retains control of border and padding to ensure that the grid lines up.
var GridBody = (0, _mobxReact.observer)((_class = function (_React$Component) {
  _inherits(GridBody, _React$Component);

  function GridBody(props) {
    _classCallCheck(this, GridBody);

    var _this = _possibleConstructorReturn(this, (GridBody.__proto__ || Object.getPrototypeOf(GridBody)).call(this, props));

    _initDefineProp(_this, 'scrollBarWide', _descriptor, _this);

    (0, _reactAutobind2.default)(_this);
    _this.componentWillReceiveProps(props); // first call needs to set up the data store
    _this.uiMath = new _GridMath2.default();
    return _this;
  }

  _createClass(GridBody, [{
    key: 'setScrollBarWide',
    // keep track of how wide the scroll bar will be
    value: function setScrollBarWide(exp) {
      this.scrollBarWide = exp.scrollbarWidth + 2;
    } // account for rounding error


  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.GridStore) {
        this.props.GridStore.prepSelectionField(nextProps);
      } else {
        console.log('missing grid store');
      }
    }
  }, {
    key: 'blurControl',
    value: function blurControl(evt) {
      // brain dead LUCK is the only thing making this work.
      // when moving focus in the cell, it sets autoFocus true.
      // then it renders all the cells and one of them takes focus, focusing the new cell and bluring the old one.
      // the blur event comes here and tells us to not steal focus any more.
      // Now we can type into other things all day.  But only if we click into a cell will the focus move with us.  Lucky!
      this.props.GridStore.autoFocus = false;
    }
  }, {
    key: 'addRow',
    value: function addRow() {
      // JJHNOTE: pivot support needed.  Will reuse column add/cut when that is built.
      this.props.GridStore.onRowAdd(this.props.GridStore.cursor.x, this.props.GridStore.cursor.y, this.props.GridStore.keyList[this.props.GridStore.cursor.x]);
    }
  }, {
    key: 'cutRow',
    value: function cutRow() {
      // JJHNOTE: pivot support needed.  Will reuse column add/cut when that is built.
      this.props.GridStore.onRowCut(this.props.GridStore.cursor.x, this.props.GridStore.cursor.y, this.props.GridStore.keyList[this.props.GridStore.cursor.x]);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var ui = this.uiMath.calcGridBody(this.props, this.scrollBarWide || 20);
      if (this.props.debugGridMath) {
        console.log(ui);
      }

      if (this.props.editAsText) {
        // forget this complex grid nonsense.  Just make a big text area and edit the stuff that way.
        return _react2.default.createElement(_GridTextBox2.default, _extends({}, this.props, { uiMath: ui }));
      }

      if (ui.notReady) {

        return _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_reactScrollbarSize2.default, {
            onLoad: this.setScrollBarWide,
            onChange: this.setScrollBarWide
          }),
          'Loading...'
        );
      }

      var header = [];
      var marginOffset = 0;
      var headerUsage = 0;
      if (!this.props.colHeaderHide) {
        // provide a header row.
        for (var ctr = 0; ctr < ui.keyNames.length; ctr++) {

          var keyName = ui.keyNames[ctr]; // what key am I on?
          var colTitle = keyName;
          var curColWide = ui.autoColWide;
          var helpComp = null;
          if (this.props.GridStore.colDefList[keyName]) {
            // is there a colDef that uses this key?
            colTitle = this.props.GridStore.colDefList[keyName].title || keyName; // if there is a title for the colDef use it, or just stick with thekey

            if (this.props.GridStore.colDefList[keyName].widePx) {
              // width by px
              curColWide = this.props.GridStore.colDefList[keyName].widePx;
            } else if (this.props.GridStore.colDefList[keyName].widePct) {
              // width by pct
              curColWide = ui.rowWide * (this.props.GridStore.colDefList[keyName].widePct / 100);
            }

            if (this.props.pivotOn) {
              // handle pivoted alt text.  Note that the 'text' could be a component.  regular header
              if (ctr > 0) {
                if (this.props.GridStore.colDefList[this.props.GridStore.keyList[ctr - 1]].altText) {
                  helpComp = this.props.GridStore.colDefList[this.props.GridStore.keyList[ctr - 1]].altText;
                }
              }
            } else {
              // handle alt text.  Note that the 'text' could be a component.  regular header
              if (this.props.GridStore.colDefList[keyName].altText) {
                helpComp = this.props.GridStore.colDefList[keyName].altText;
              }
            }
          }
          // NOTE: check for header components here.
          if (ctr === 0 && this.props.pivotOn && ui.pivotRowHeaderWide) {
            curColWide = Number(ui.pivotRowHeaderWide);
          }

          curColWide = curColWide + 'px';

          header.push(_react2.default.createElement(
            'a',
            { 'data-tip': true, 'data-for': 'dataTip' + ctr, key: ctr },
            _react2.default.createElement(
              'div',
              {
                style: _extends({
                  backgroundColor: '#F3F3F3', // default, may be over ridden by styleHeader. Order matters.
                  textAlign: 'center' }, this.props.styleHeader, { // user specified styles.
                  width: curColWide, // everything from here down cannot be over-ridden by the user.
                  maxWidth: curColWide, // everything from here down cannot be over-ridden by the user.
                  borderStyle: 'solid',
                  borderWidth: ui.borderWide,
                  padding: ui.padWide + 'px',
                  display: 'inline-block',
                  marginLeft: marginOffset,
                  overflow: 'hidden',
                  boxSizing: 'content-box',
                  height: ui.colHeaderHigh + 'px',
                  maxHeight: ui.colHeaderHigh + 'px' }) },
              colTitle,
              helpComp && // only render this if helpComp is defined
              _react2.default.createElement(
                _reactTooltip2.default,
                { id: 'dataTip' + ctr },
                helpComp
              )
            )
          ));
          marginOffset = -1 * ui.borderWide;
        }
        headerUsage = ui.colHeaderHigh + 2 * ui.padWide + 2 * ui.borderWide;
      } else {
        // header is hidden so provide a top border line.
        header.push(_react2.default.createElement('div', { style: _extends({}, this.props.styleHeader, {
            width: ui.borderWide + ui.keyNames.length * (ui.autoColWide + ui.borderWide + ui.padWide + ui.padWide) + 'px',
            borderTopStyle: 'solid', borderTopWidth: ui.borderWide, height: '0px' }) }));
        headerUsage = 1;
      }

      var retVal = _react2.default.createElement(
        'div',
        { style: { height: ui.gridHigh, width: ui.gridWide + 'px' }, onKeyPress: this.onKeyPress, onBlur: this.blurControl },
        _react2.default.createElement(_reactScrollbarSize2.default, {
          onLoad: this.setScrollBarWide,
          onChange: this.setScrollBarWide
        }),
        _react2.default.createElement(
          'div',
          { style: { padding: '0px', margin: '0px', maxHeight: '' + headerUsage + 'px', minHeight: '' + headerUsage + 'px', height: '' + headerUsage + 'px' } },
          header
        ),
        (this.props.GridStore.showDatePicker || this.props.GridStore.showDateTimePicker) && _react2.default.createElement(_DatePickerOverlay2.default, { GridStore: this.props.GridStore, uiMath: ui }),
        this.props.GridStore.showMenuPicker && _react2.default.createElement(_MenuPickerOverlay2.default, { GridStore: this.props.GridStore, uiMath: ui }),
        _react2.default.createElement(_AltTextOverlay2.default, { GridStore: this.props.GridStore, uiMath: ui }),
        _react2.default.createElement(_reactTinyVirtualList2.default, {
          width: '100%',
          height: ui.gridHigh - headerUsage,
          itemCount: ui.fixedRowCount,
          itemSize: ui.rowHighWithPad + ui.borderWide,
          renderItem: function renderItem(_ref) {
            var index = _ref.index,
                style = _ref.style;
            return _react2.default.createElement(
              'div',
              { key: index, style: style },
              _react2.default.createElement(_GridRow2.default, { data: _this2.props.data,
                GridStore: _this2.props.GridStore,
                styleInput: _this2.props.styleInput,
                styleCell: _this2.props.styleCell,
                styleRowHeader: _this2.props.styleRowHeader,
                uiMath: ui,
                pivotOn: _this2.props.pivotOn,
                onChange: _this2.props.onChange,
                index: index
              })
            );
          }
        }),
        ui.showBottomGridLine && _react2.default.createElement('div', { style: _extends({}, this.props.styleHeader, {
            width: ui.rowWide + 'px',
            borderTopStyle: 'solid',
            borderTopWidth: ui.borderWide,
            height: '0px' }) }),
        this.props.showToolsAddCut && _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'button',
            { onClick: this.addRow },
            _react2.default.createElement(_PlaylistPlusIcon2.default, null)
          ),
          _react2.default.createElement(
            'button',
            { onClick: this.cutRow },
            _react2.default.createElement(_PlaylistRemoveIcon2.default, null)
          )
        )
      );

      return retVal;
    }
  }]);

  return GridBody;
}(_react2.default.Component), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'scrollBarWide', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return 0;
  }
}), _applyDecoratedDescriptor(_class.prototype, 'setScrollBarWide', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setScrollBarWide'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'blurControl', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'blurControl'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'addRow', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'addRow'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'cutRow', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'cutRow'), _class.prototype)), _class));

exports.default = GridBody;
module.exports = exports['default'];